// Voltmeter_serial
// LCD module connections
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;

sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;
// End LCD module connections

unsigned int Radc = 0;              // Guarda los datos de la lectura del AN2
unsigned int vcc = 0;             // Voltaje temporal tipo entero
char *VDD = "000.0";              // Apuntador, Voltaje final
char Text[15];                      // Cadena para conversion FloatToStr
char text1[] = "VOLTAGE:";
float voltage = 0.0;                  // Variable para procesos

void volt(){
if(vcc < 10000){
   VDD[0] = ' ';
   VDD[1] = (vcc/1000)%10 + 48;
   VDD[2] = (vcc/100)%10 + 48;
   VDD[4] = (vcc/10)%10 + 48;
   Lcd_Out(2,4,VDD);
   UART1_Write_Text(VDD);
   UART1_Write(0x0D);              // ASCII - Retorno de Carro
   UART1_Write(0x0A);              // ASCII - Avance de Linea
   Delay_ms(20);
 } else{
    VDD[0] = (vcc/10000)%10 + 48;
    VDD[1] = (vcc/1000)%10 + 48;
    VDD[2] = (vcc/100)%10 + 48;
    VDD[4] = (vcc/10)%10 + 48;
    Lcd_Out(2,4,VDD);
    UART1_Write_Text(VDD);
    UART1_Write(0x0D);              // ASCII - Retorno de Carro
    UART1_Write(0x0A);              // ASCII - Nueva Linea
    Delay_ms(20);
 }


}

void set_up() {
  ANSEL = 0x04;      // Pin RA2 se configura como una entrada analgica
  TRISA = 0x04;
  ADCON1 = 0x82;    // elvoltage de referencia es Vcc
  ANSELH = 0;      // Los dems pines se configuran como digitales
  C1ON_bit = 0;    // se desactivan los comparadores analgicos
  C2ON_bit = 0;

 ADC_Init();                 // Iniciar modulo ADC
 UART1_Init(9600);           // Iniciar comunicacion Serial
 Delay_ms(100);              // Retardo para estabilizar Modulos
 LCD_Init();                 // Iniciar LCD
 Lcd_Cmd(_LCD_CLEAR);        // Limpieza del LCD
 Lcd_Cmd(_LCD_CURSOR_OFF);   // Apagar cursor del LCD
 Lcd_Out(1,4,text1);         // Muestra el texto en el LCD
 Lcd_Chr(2,9,'v');
 Delay_ms(100);              // Retardo para estabilizar Modulos
}

 void main() {
  set_up();
while(1){
  Radc = ADC_Get_Sample(2);      // Lectura del Canal AN2
  voltage = (float)(Radc * 0.05); // Obtencion del valor real de la conversin
  vcc = (voltage*100);           // Para mas informacion ir al articulo del blog
  FloatToStr(voltage,Text);        // Se convierte de float a char
  volt();
  Delay_ms(600);                 // Regula la velocidad en la cual se realizara
                                           // la conversion.
 }
}